
#ifndef CUSTOM_GPIO_H
#define CUSTOM_GPIO_H

#include "x_pdwnc.h"
#include "drv_pwm.h"

//#include "CustomCtrl.h"
#ifndef CC_UBOOT
#include "CustomCtrl.h"
#else
#include "eeprom_if.h"
#ifdef TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
#include TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
#endif
#endif
//---------------------------------------------------------------------------
// Customer function definitions
//---------------------------------------------------------------------------
#ifndef CC_UBOOT
#define GPIO_POWER_ON_FUNC      (GPIO_CustomPowerOnFunc)
#define GPIO_POWER_OFF_FUNC     (GPIO_CustomPowerOffFunc)
#define GPIO_LED_CTRL_FUNC      (GPIO_CustomLedCtrlFunc)
#else
#define GPIO_POWER_ON_FUNC      (NULL)
#define GPIO_POWER_OFF_FUNC     (NULL)
#ifdef CC_SUPPORT_USB_DIRECT_UART 
#define GPIO_LED_CTRL_FUNC      (GPIO_CustomLedCtrlFunc)
#else
#define GPIO_LED_CTRL_FUNC   (NULL)
#endif
#define LOADER_ENV_INIT_FUNC    (NULL)
#endif

#ifdef CC_MTK_LOADER
//#define LOADER_UPGRADE_VER_CMP_FUNC             (NULL)
#ifndef CC_UBOOT
#define LOADER_USB_UPGRADE_CHECK_FUNC IsCustomLdrSkipUpgrade
#define LOADER_UPGRADE_DLM_CB_FUNC              (_LdrUpgradeDlmCbFunc)
#define LOADER_UPGRADE_DLM_GET_TAG_VER_CB_FUNC  (_LdrUpgradeDlmGetTagVerCbFunc)
#define LOADER_UPGRADE_DLM_CMP_TAG_VER_CB_FUNC  (_LdrUpgradeDlmCmpTagVerCbFunc)
#else
#define LOADER_UPGRADE_DLM_CB_FUNC              (NULL)
#define LOADER_UPGRADE_DLM_GET_TAG_VER_CB_FUNC  (NULL)
#define LOADER_UPGRADE_DLM_CMP_TAG_VER_CB_FUNC  (NULL)
#endif
//#define LOADER_UPGRADE_BREAK_HANDLE_FUNC        (_LdrUpgradeBreakFunc)
#else
#if 1//def CC_MODEL_DETECT_SUPPORT
#define CUSTOMER_POWER_ON_SEQUENCE              (CustomPowerOnSequence)
#define CUSTOMER_POWER_OFF_SEQUENCE             (CustomPowerOffSequence)
#endif

#define LOGO_NOTIFY_FUNC                        (CustomLogoNotifyFunc)
#define CUSTOMER_LOGO_DISPLAY_FUNC              (CustomDisplayLogo)
#endif /* CC_MTK_LOADER */

#ifdef CUSTOM_POWER_STATE_CTRL_ENABLE
#ifndef CC_UBOOT
#define LOADER_CEC_CONFIG_QUERY_FUNC            (CustomCheckCECCtrlState)
#define POWER_STATE_QUERY_FUNC                  (PDWNC_Custom_CheckPowerState)
#endif
#endif /* CUSTOM_POWER_STATE_CTRL_ENABLE */

//---------------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------------
#define CUSTOM_IR_LED_BLINK_PERIOD              150         // 150ms


// Strap GPIO definitaion on PCB
#define CUSTOM_GPIO_PANEL_NVM_WP                GPIO(58)//PANEL_B_INT: GPIO58
#define CUSTOM_GPIO_PANEL_ID_PIN_0              GPIO(0xffffffff)

#define CUSTOM_PCB_TYPE_1_WXGA                  0x00
#define CUSTOM_PCB_TYPE_1_FHD                   0x01
#define CUSTOM_PCB_TYPE_2                       0x02
#define CUSTOM_PCB_TYPE_3                       0x03
#define CUSTOM_PCB_TYPE_5                       0x05

#define CUSTOM_GPIO_PANEL_NONTCON               3
#define CUSTOM_GPIO_PANEL_OTHER                 2
#define CUSTOM_GPIO_PANEL_WXGA                  1
#define CUSTOM_GPIO_PANEL_FHD                   0
#define CUSTOM_GPIO_LVDS_OTHER_BIT              2
#define CUSTOM_GPIO_LVDS_10BIT                  1
#define CUSTOM_GPIO_LVDS_8BIT                   0
#define CUSTOM_GPIO_FACTORY_SONY                0
#define CUSTOM_GPIO_FACTORY_WISTRON             1
#define CUSTOM_GPIO_DVD_NA                      0
#define CUSTOM_GPIO_DVD_INCLUDE                 1
#define CUSTOM_GPIO_FHD_CMO_37                  0
#define CUSTOM_GPIO_FHD_OTHER                   1
#define CUSTOM_GPIO_AUD_NORMAL                  0
#define CUSTOM_GPIO_AUD_WOOFER                  1
#define CUSTOM_GPIO_LIGHT_SENSOR_INCLUDE        0
#define CUSTOM_GPIO_LIGHT_SENSOR_NA             1
#define CUSTOM_GPIO_THERMAL_SENSOR_NA           0
#define CUSTOM_GPIO_THERMAL_SENSOR_INCLUDE      1
#define CUSTOM_PCB_TYPE_1H						0
#define CUSTOM_PCB_TYPE_2H						1


#define CUSTOM_PANEL_WIDTH_FHD                  1920
#define CUSTOM_PANEL_WIDTH_WXGA                 1366

#ifdef CC_ENABLE_HDMI_JTAG
// LED GPIO
#define CUSTOM_GPIO_LED_STANDBY  0xffffffff
#else 
#define CUSTOM_GPIO_LED_STANDBY                 GPIO(208)  //STBY_LED: OPCTRL(8)
#endif
#define CUSTOM_GPIO_LED_POWER                   GPIO(202)     //POWER_LED: OPCTRL(2)

#define CUSTOM_GPIO_LED_AMBER                   GPIO(206)     //WHITE_LED: OPCTRL(6)
#define CUSTOM_LED_AMBER_ON_VAL                 1

#define CUSTOM_GPIO_LED_POWER_SECONDARY         0xffffffff//GPIO(206)
#define CUSTOM_GPIO_LED_TIMER_AMBER             0xffffffff  //OPCTRL(5)     // ADIN5
#define CUSTOM_GPIO_LED_TIMER_GREEN             0xffffffff  // GPIO 26
#define CUSTOM_LED_POWER_ON_VAL                 1
#define CUSTOM_LED_STANDBY_ON_VAL               1
#define CUSTOM_LED_TIMER_ON_VAL                 1
#if 0//d140621_Haibo:Blink led in led ctrl.c
#define IRRX_LED_BLINK_GPIO                     CUSTOM_GPIO_LED_POWER
#define IRRX_LED_BLINK_ON_VAL                   CUSTOM_LED_POWER_ON_VAL

#define IRRX_OPT_LED_BLINK_GPIO                 CUSTOM_GPIO_LED_STANDBY
#define IRRX_OPT_LED_BLINK_ON_VAL               CUSTOM_LED_STANDBY_ON_VAL
#endif
#define IRRX_LED_BLINK_DURATION                 CUSTOM_IR_LED_BLINK_PERIOD 

#define T8032_CTRL_ERR_LED                      CUSTOM_GPIO_LED_STANDBY
#define T8032_CTRL_ERR_LED_ON_VAL               CUSTOM_LED_STANDBY_ON_VAL

// Power Key
#define BUTTON_POWER_KEY                         OPCTRL(7)
//#define BUTTON_POWER_KEY_SRV_NUM                SERVO(3)
//#define POWER_KEY_SRV_AD_HI_THR                 240
//#define POWER_KEY_SRV_AD_LOW_THR                210

// Shutdown status
#define CUSTOM_SHUTDOWN_ERROR                   (1 << 0)
#define CUSTOM_SHUTDOWN_AC_DET                  (1 << 1)
#define CUSTOM_SHUTDOWN_DISABLE_STANDBY_LED     (1 << 2)

//#define CUSTOM_GPIO_HOTEL_MODE                  OPCTRL4//GPIO(44)       
//#define CUSTOM_HOTEL_MODE_ON_VAL                 0
//#define CUSTOM_HOTEL_MODE_OFF_VAL                 (1-CUSTOM_HOTEL_MODE_ON_VAL)

#if 0//remove to common.cfg sincee preloader need this inforamtion
#ifdef CC_SUPPORT_USB_DIRECT_UART
#define USB_DIRECT_UART_SWITCH_GPIO  84
#define USB_DIRECT_UART_SWITCH_GPIO_POL 1//1:usb 0:uart
#endif
#endif

#ifdef DEFAULT_HDMIHPD1_GPIONUM
#undef DEFAULT_HDMIHPD1_GPIONUM
#define DEFAULT_HDMIHPD1_GPIONUM 0xffffffff
#endif
//-----------------------------------------------------------------------------
// Macros
//-----------------------------------------------------------------------------

#define INIT_SET_GPIO(gpio, onval)                                  \
    if (DRVCUST_InitQuery(gpio, &i)==0)                             \
    {                                                               \
        if (DRVCUST_InitQuery(onval, (UINT32 *)&i4Val)==0)          \
        {                                                           \
            VERIFY(GPIO_Output((INT32)i, &i4Val) == i4Val);         \
        }                                                           \
    }

#define DOWN_SET_GPIO(gpio, onval)                                  \
    if (DRVCUST_InitQuery(gpio, &i)==0)                             \
    {                                                               \
        if (DRVCUST_InitQuery(onval, (UINT32 *)&i4Val)==0)          \
        {                                                           \
            i4Val = !i4Val;                                         \
            VERIFY(GPIO_Output((INT32)i, &i4Val)== i4Val);          \
        }                                                           \
    }
#define UART_SELECTION_IS_FACTORY() \
( \
{ \
  		 UINT32 uart_sel=0;\
	     EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
         ((uart_sel==UART_SELECTION_SONY_FACTORY) || (uart_sel==UART_SELECTION_USB_FACTORY) || (uart_sel==UART_SELECTION_TTY_USB_FACTORY)); \
} \
)
#define UART_SELECTION_IS_UART_OFF() \
( \
{ \
  		 UINT32 uart_sel=0;\
	     EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
         ((uart_sel==UART_SELECTION_SILENT) || (uart_sel==UART_SELECTION_HOTEL_SONY_LOCATEL) || (uart_sel==UART_SELECTION_HOTEL_SONY_VDA)); \
} \
)
#define UART_SELECTION_IS_HOTEL() \
( \
{ \
  		 UINT32 uart_sel=0;\
	     EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
        ((uart_sel==UART_SELECTION_HOTEL_SONY_STANDARD) || (uart_sel==UART_SELECTION_HOTEL_SONY_LOCATEL) || (uart_sel==UART_SELECTION_HOTEL_SONY_VDA)); \
} \
)
		
#define UART_SELECTION_IS_USB_DIRECT_UART() \
( \
{ \
  		 UINT32 uart_sel=0;\
	     EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
         ((uart_sel==UART_SELECTION_USB_LOG) || (uart_sel==UART_SELECTION_USB_FACTORY)); \
} \
)
#define UART_SELECTION_IS_TTY_USB_LOG() \
( \
{ \
  		 UINT32 uart_sel=0;\
	     EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
         ((uart_sel==UART_SELECTION_TTY_USB_LOG)); \
} \
)
#define UART_SELECTION_IS_USB_ETH() \
	( \
	{ \
			 UINT32 uart_sel=0;\
			 EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&uart_sel, 1);\
			 ((uart_sel==UART_SELECTION_SONY_FACTORY)); \
	} \
	)

#define _IS_UART_OFF_MODE UART_SELECTION_IS_UART_OFF()

enum
{
   USB_DIRECT_UART_TO_USB,
   USB_DIRECT_UART_TO_UART
};
#ifdef CC_SUPPORT_USB_DIRECT_UART
#define USB_DIRECT_UART_SWITCH(selection) \
       if(selection==USB_DIRECT_UART_TO_UART) \
	   { \
	        UINT32 u4Gpio; \
			UINT32 u4GpioPolarity; \
			if((0 == DRVCUST_InitQuery(eUSBVbus0Gpio, &u4Gpio)) && (0 == DRVCUST_InitQuery(eUSBVbus0EnablePolarity, &u4GpioPolarity))) \
			{ \
    		   GPIO_SetOut(u4Gpio,u4GpioPolarity?0:1); \
			   Printf("Turn off VBUS0\n"); \
			} \
			Printf("Please remove the USB device!!!!!\n"); \
			SerWaitTxBufClear();\
			GPIO_SetOut(USB_DIRECT_UART_SWITCH_GPIO,USB_DIRECT_UART_SWITCH_GPIO_POL?0:1); \
	   } \
	   if((selection==USB_DIRECT_UART_TO_USB) && (BSP_PinGet(PIN_U0TX) != 2)) \
	   { \
	       GPIO_SetOut(USB_DIRECT_UART_SWITCH_GPIO,USB_DIRECT_UART_SWITCH_GPIO_POL); \
	   } \

#else
#define USB_DIRECT_UART_SWITCH(selection)
#endif

#define _IS_USB_LOG_MODE (UART_SELECTION_IS_TTY_USB_LOG() && (BSP_PinGet(PIN_U0TX) != 2))

#define _IS_USB_ETH_MODE UART_SELECTION_IS_USB_ETH()
#ifdef CC_UBOOT	
#ifdef CC_SUPPORT_USB_DIRECT_UART 	
void GPIO_CustomLedCtrlFunc(LED_STATUS_T eLedStatus)
{
    switch(eLedStatus)
	{
    	case eLedUsbPowerOn:	
		{
          if(!UART_SELECTION_IS_USB_DIRECT_UART())//switch to USB
		  {
		     GPIO_SetOut(USB_DIRECT_UART_SWITCH_GPIO,USB_DIRECT_UART_SWITCH_GPIO_POL); 
		  }
		  else//switch to uart
		  {
		     GPIO_SetOut(USB_DIRECT_UART_SWITCH_GPIO,USB_DIRECT_UART_SWITCH_GPIO_POL?0:1); 
		  }
		 }
		break;
        default:
        break;	
	}		
}
#endif	
#ifdef CC_BGM_SUPPORT_WOL
static BOOL _uboot_support_mmac_init(void)
{
    DTVCFG_T rDtvCfg;
	
    if (EEPDTV_GetCfg(&rDtvCfg) != 0)
	 {
	    printf("[WOL]Read DTV CFG fails\n");	
	    return TRUE;
	 }

	
    if((_PDWNC_ReadWakeupStatus(0) & WAK_RTC) && (rDtvCfg.u1Flags3 & (UINT8)DTVCFG_FLAG3_WAKEUP_ON_LAN) && rDtvCfg.u1Flags2 & DTVCFG_FLAG2_QUIET_BOOT)
	{
	   return FALSE;
	}
	return TRUE;
}
#define UBOOT_SUPPORT_ETH_MMAC_INIT _uboot_support_mmac_init()
#endif
#endif
//-----------------------------------------------------------------------------
// Structure definition
//-----------------------------------------------------------------------------
typedef struct _LedCtrl
{
    D_LED_TYPE eLedType;
    UINT32 u4LedState;
} LED_CTRL_STATE;

//-----------------------------------------------------------------------------
// Prototypes
//-----------------------------------------------------------------------------
void GPIO_CustomPowerOnFunc(void);
void GPIO_CustomPowerOffFunc(UINT32 u4PowerDownEn);
void GPIO_CustomLedCtrlFunc(LED_STATUS_T eLedStatus);
void CustomPowerOnSequence(void);
void CustomPowerOffSequence(void);
UINT32 CustomModelQueryFunc(VOID);
void _LdrUpgradeBreakFunc(void);
void _LdrUpgradeDlmCbFunc(UINT32 u4BufSize);
void _LdrUpgradeDlmGetTagVerCbFunc(UCHAR* ucTagName, CHAR *szCurVer);
INT32 _LdrUpgradeDlmCmpTagVerCbFunc(UCHAR* ucTagName, CHAR *szCurVer, CHAR *szUpgVer);
BOOL IsCustomLdrSkipUpgrade(void);
#endif /* CUSTOM_GPIO_H*/

